<?php
/*
Plugin Name: Mail supervisor
Version: 1.5.4
Description: Mail supervisor surveille l'envoie des mails.
Plugin URI: http://piwigo.org/ext/extension_view.php?eid=315
Author: cljosse
Author URI:http://cljosse.free.fr
*/
if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
if (!defined('mail_superv_DIR')) define('mail_superv_DIR' , basename(dirname(__FILE__)));
if (!defined('MAIL_SUPERV_PATH')) define('MAIL_SUPERV_PATH' , PHPWG_PLUGINS_PATH.basename(dirname(__FILE__)).'/');

$MAIL_SUPERV_PATH_ABS = str_replace('\\','/',dirname(__FILE__) );
if (!defined('MAIL_SUPERV_PATH_ABS')) define(  'MAIL_SUPERV_PATH_ABS',   $MAIL_SUPERV_PATH_ABS."/");

global $conf,$mails_options ;
include_once (MAIL_SUPERV_PATH.'include/constants.php');
include_once(MAIL_SUPERV_PATH.'mail_super.inc.php');

$mail_supervisor = new mail_supervisor();
add_event_handler('get_admin_plugin_menu_links', array(&$mail_supervisor,'admin_menu')  );

mail_supervisor::Get_Options($mails_options,"mail_superv");

/* EVENT_HANDLER_PRIORITY_NEUTRAL  */
//
//
include_once (PHPWG_ROOT_PATH.'include/functions_mail.inc.php' );
include_once (MAIL_SUPERV_PATH.'include/fonctions.php');
//===============loc_begin_index 
//====           loc_begin_page_header
//==========     loc_after_page_header 
add_event_handler('loc_after_page_header',  array(&$mail_supervisor,'init')  );
add_event_handler('loc_begin_page_tail',  array(&$mail_supervisor,'affiche_message')  );

include_once(MAIL_SUPERV_PATH.'mail_send.inc.php');
$clj = new clj();

add_event_handler('send_mail',array(&$clj,'send_mail'),EVENT_HANDLER_PRIORITY_NEUTRAL - 1, 6);
add_event_handler('send_mail_to',array(&$clj,'send_mail_to') );
add_event_handler('send_mail_subject',array(&$clj,'send_mail_subject') );
add_event_handler('send_mail_content',array(&$clj,'send_mail_content') );
add_event_handler('send_mail_headers',array(&$clj,'send_mail_headers'),EVENT_HANDLER_PRIORITY_NEUTRAL,6 );

//==========================================================================================
//add_event_handler('send_mail', 'clj_send_mail',EVENT_HANDLER_PRIORITY_NEUTRAL - 10, 6);

function clj_send_mail($result, $mailto, $subject, $content, $headers, $args) {
  global $conf, $user, $lang_info;
  global $conf_mail,$mails_options,$mails_donnees ;
  global  $template,$page ,$erreur_message,$infos_message, $lang;
  global $errors;
  // lecture config table -------------
  

  include_once (MAIL_SUPERV_PATH.'include/fonctions.php');
  load_language('plugin.lang', MAIL_SUPERV_PATH);

  $arg_trigg= array($mailto, $subject, $content, $headers, $args);

    trigger_event('mail_supervisor_clj_mail',$arg_trigg);

 // remove_event_handler('send_mail', 'pwg_send_mail');
    $message ="";
  if (!isset($infos_message))   {   $infos_message = "";    }
  if (!isset($erreur_message))  {   $erreur_message = '';   }

  // $mails_options = explode("," , $conf['mail_superv']);
  $envoie_ok=true ;
  //======== verification si envoie de mail ou blocage connexion =====================

  if ($mails_options['no_mail_list']=='on' || $mails_options['no_connect'] == 'on' )    {
    if (kill_list()) {
      $nb_destinataires=0; ;
      $envoie_ok= false ;
      $erreur_message .= "<BR />".l10n('Sv_is_a_spam') ;
      $infos_message = l10n('Sv_mail_not_send')."<BR />";
      if ($mails_options['no_connect'] == 'on' ){          
          if ($user['status'] == 'webmaster'){
          //---------- continuer si web master ----------
          }else{
             trigger_event('mail_supervisor_send_mail', "DIE(KILL) : " . $ip . ' = ' . $user['status']);
              if (!isset($_GET['admin'])) {
                      die('Blacklist : <br />' .$erreur_message. '<br /> Hacking attempt!');
                        }elseif   ($_GET['admin'] != 'piwigo')
                            {
                      die('blacklist Hacking attempt!');
              }
          }
      }
      trigger_event('mail_supervisor_send_mail', "Kill : " . $ip . ' = ' . $user['status'] . "noconnect==off");
      return true;
      }
    }
  // lecture donnees       -------------
  $mails_donnees = mail_supervisor::Get_Datas();
  $nb_mails   = $mails_donnees['nb_mails'] ;
  $next_day  =  $mails_donnees['date_mail'] ;
  $reste =    $mails_donnees['reste'] ;
    $rest_mail =    $mails_donnees['rest_mail'] ;
    if ($rest_mail <=0 || $mails_donnees['nb_mails'] ==0 ){
       $mails_donnees['nb_mails'] =0 ;
       $mails_donnees['date_mail'] = time();
    }
    $rest_spam =    $mails_donnees['rest_spam'] ;
    if ($rest_spam <=0 || $mails_donnees['nb_spams'] ==0 ){
       $mails_donnees['nb_spams'] =0 ;
       $mails_donnees['date_spam'] = time();
    }
    $alerte =   ( $mails_donnees['reste'] >0 ) ? true : false ;
    $alerte_mail =    ( $mails_donnees['nb_mails'] >   $mails_donnees['nb_mails_maxi']-1 ) ? true : false ;
    $alerte_spam =    ( $mails_donnees['nb_spams'] >   $mails_donnees['nb_spams_maxi']-1 ) ? true : false ;

  if ( ( !$alerte  && !$alerte_spam  && !$alerte_mail ) ) {
    $nb_destinataires=0;
  //====================================================
    $match_email = $conf_mail['email_webmaster'];

    $new_args=array();
    if( isset($args['Bcc']))
    foreach($args['Bcc'] as $key => $val){
      if (!preg_match('/'. $match_email.'/', $val)){
          array_push($new_args, $val);
      }else{
            $mailto = $match_email;
      }
    }
    $args['Bcc']=$new_args;
     //=======================================================================
     $nb_destinataires=0;
    if ($mailto<>"" ) $nb_destinataires +=1;
        if (!empty($args['Cc']))  {
        $nb_destinataires += count($args['Cc']);

    }
        if (!empty($args['Bcc']))  {
        $nb_destinataires += count($args['Bcc']);
    }
    if ($mailto == "" && $nb_destinataires==0 ) {
      $mailto = $conf_mail['email_webmaster'];
      $nb_destinataires ++;
    }

        if ($mails_options['check_mailto'] == 'on') {
            if ($mailto == "" && $nb_destinataires > 1 )    $mailto = $conf_mail['email_webmaster'];
        }

    $infos_message .= "nb_destinataires : $nb_destinataires Theme :" . ($args['theme'] ) ."{". $lang_info['language_name'] ."}"."<br />";
    //================= réecriture de l'entete ===============================
    $match=array("<",">");
    $string=array("&lt;","&gt;") ;
    if ( $nb_destinataires  == 1 ) {
      if ($mailto == "" ) {
        if (!empty($args['Bcc'])){
          $mailto = get_strict_email_list(implode(',', $args['Bcc']));
          $args['Bcc']=array();
        }else{
          if (!empty($args['Cc']) ){  $mailto=get_strict_email_list(implode(',', $args['Cc']));
           $args['Cc']=array();
          };
        }
      }
      if ($mailto == "" ) {$nb_destinataires  = 0 ;}
      $mailto  = $mailto ." \n"   ;
      $headers =  preg_replace('/.*Bcc(.*).\n/i', '', $headers);
      $headers =  preg_replace('/.*Cc(.*).\n/i', '', $headers);
      $infos_message .="Destinataire:" .$mailto ;
      //=============================================================================

    }else{
          //=== plusieurs destinataires ===========
      $cl_list_mail="";
      if ($mailto !="") $infos_message .="To: " . $mailto . " "."<br />" ;
      if (!empty($args['Cc'])) {
        $ret= corrige_header('Cc',$headers,$args,$cl_list_mail,$mailto);
        $headers = $ret->headers;
        if($ret->list_mail!="") $infos_message .="Cc: " .  ( $ret->list_mail)."  <br />" ;

      }
      if (!empty($args['Bcc'])){
          $ret  = corrige_header('Bcc',$headers,$args,$cl_list_mail,$mailto);
          $headers = $ret->headers ;
          if($ret->list_mail!="") $infos_message .="Bcc: " . ( $ret->list_mail) ."  <br />";

       }
         $infos_message .=  " " ;
    }
   
     //======================================================
     // si adresse avec ip , certaine boite aux lettres traite ces messages 
     //  en spam (orange+windowsmail)
     //======================================================
      if ( $mails_options['no_ipaddress'] == 'on' ){    
        $pattern ="/(http:\/\/)(((25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9]{1}[0-9]|[1-9])\.){1}((25[0-5]|2[0-4][0-9]|[1]{1}[0-9]{2}|[1-9]{1}[0-9]|[0-9])\.){2}((25[0-5]|2[0-4][0-9]|[1]{1}[0-9]{2}|[1-9]{1}[0-9]|[0-9]){1}))/" ;        
        if(preg_match($pattern, $content)){
          $replacement = "http://localhost"; 
          $content = preg_replace( $pattern, $replacement,  $content );      
        }
      }
      //======================================================
      // drop LF barre  
      //======================================================
      $pattern="/xxxxx/";
      if(  preg_match($pattern, $mailto) ||  preg_match($pattern, $headers) ){
        $pattern="---=";
        $pattern ="/" . preg_quote($pattern, '/')."/" ;
        $pattern ="#(?<!\r)\n#si" ;
        if(  preg_match($pattern, $content)  ){
            $infos_message .= $pattern. " <br />";   
            $content= preg_replace( $pattern, "\r\n", $content);   //  
            //$content = str_replace("\n.", "\n..", $content);
        }
       

      }else{
          $pattern="/hotmail/";
          if(  preg_match($pattern, $mailto) ||  preg_match($pattern, $headers) ){
             //  
          }else{
            $pattern="/free.fr|club/";
            if(  preg_match($pattern, $mailto) ||  preg_match($pattern, $headers) ){
                $content= preg_replace('#(?<!\r)\n#si', "\r\n", $content); //drop LF barre    
            }else{
               
            }
          }
      }

  //=====================================================================
    if (!preg_match('/'. $conf_mail['boundary_key'] .'/', $headers)){
        $erreur_message .=   "<br />ERREUR manque : boundary_key dans le headers <br />";
        $infos_message = l10n('Sv_mail_not_send'); 
        $envoie_ok= false ;
        return false ;

    }
  //=====================================================================
            $ret="false";  
             ob_start();
            //======== Non mise en quarantaine =============
            //echo "warning spam" ;
           // echo " Warning: mail() has been disabled for security reasons";
         
              if ($nb_destinataires > 0) {
                if( $envoie_ok) { 
                  $ret = mail($mailto, $subject,$content, $headers);   
                }
              }else{
                $message .= l10n('Sv_no_receiver_available');
              }
              $message .= ob_get_contents();
              ob_end_clean();
              $arg_trigg= array("Nb destinataires: " . $nb_destinataires,"Mail to: ".$mailto,"content: ".$content, " Reponse : " . $message);
              trigger_event('mail_supervisor_mail', $arg_trigg );
              $mails_donnees['message']=$message;
              $ret= Gestion_erreurs($message,$ret,$nb_destinataires,$headers,$mailto, $subject,$content);
            } else {
                //================== Est en quarantaine =======================
               
                $erreur_message .=  l10n('Sv_To_day_is')."<br />";
                if ($alerte_spam ) {
                        $type="Spams";
                        $d1=$mails_donnees['nb_spams'] . '  \\  ' . $mails_donnees['nb_spams_maxi'];
                        $d2=$mails_donnees['nb_spams'];
                        $d3= $mails_donnees['rest_spam'];
                        $d4=time()+$d3 ;
                }
                if ($alerte_mail) {
                    $type="Mails";
                    $d1=$mails_donnees['nb_mails']. '  \\  ' . $mails_donnees['nb_mails_maxi'];;
                    $d2=$mails_donnees['date_mail'];
                    $d3= $mails_donnees['rest_mail'];
                    $d4=time()+$d3 ;
                }
                if ($alerte) {
                $type="Spams(Quarantaine)";
                    $d1=$mails_donnees['nb_spams'] . '  \\  ' . $mails_donnees['nb_spams_maxi'];
                    $d2=$mails_donnees['date_quarantaine'];
                    $d3= $mails_donnees['reste'];
                    $d4=time()+$d3 ;
                }
            $d2=date(l10n('Sv_formatdate'),$d2);
            $d3=int_to_heure($d3) ;
            $d4=date(l10n('Sv_formatdate'),$d4);
            if ($alerte_mail) {
                $erreur_message .='<br />'.sprintf(l10n('Sv_alerte_mail %s %s %s %s %s'),$type,$d1,$d2,$d3,$d4).'<br />';
            }else{
                $erreur_message .='<br />'.sprintf(l10n('Sv_mise_en_quarantaine %s %s %s %s %s'),$type,$d1,$d2,$d3,$d4).'<br />';
            }
                $ret = "Error ". $type." : ";
                $ret .=  l10n('Sv_mail_not_send');
               
            $infos_message .= l10n('Sv_mail_not_send');
            }
           $infos_message .= "<hr>"; 
           trigger_event('mail_supervisor_message',  $infos_message );
    mail_supervisor::sauve_donnees();
    mail_supervisor::affiche_message();
    
    return $ret  ;// 
}
//===========================================================================================
function Gestion_erreurs($message,$ret,$nb_destinataires,$headers,$mailto, $subject,$content){
     global $conf, $user,  $conf_mail,$mails_options,$mails_donnees , $template,$page ,$infos_message,$erreur_message,$args,$lang, $lang_info;
     $match=array("<",">");
     $string=array("&lt;","&gt;") ;
     //  $headers=str_replace( $match,$string, $headers);
    // Warning: mail() has been disabled for security reasons
    $est_un_spam =!(strpos(strtolower($message), 'spam') === false);  
    if ( ($ret==false) || ($est_un_spam==true) || ($nb_destinataires == 0) ) {
     //=============== La fonction mail retourne une erreur =========================
        $ret="Error";
        // Bad recipient address syntax
        $pos1 = strpos(strtolower($message), 'bad recipient address syntax');
        if (  !($pos1 === false) ){
            $erreur_message .= l10n('Sv_detection_de').' Bad recipient address syntax .';
            $erreur_message .= l10n('Sv_verifiez_les_destinataires').' (Bcc,Cc,To)<br />';
            }               
        $erreur_message .=$ret . " : <br />".sprintf(l10n('Sv_debug_message'),
                              ($ret==true)? "true" : "false",
                              htmlspecialchars($message) ,
                              htmlspecialchars( $mailto) ,
                              htmlspecialchars($subject) ,
                              htmlspecialchars($headers) ,
                              htmlspecialchars($content) ,
                              $nb_destinataires );

     Mail_supervisor_log($mailto,$erreur_message) ;   
           
      }else{            
    if( isset($mails_options['debug_mail']) && $mails_options['debug_mail']=="on") {
              $infos_message .="DEBUG : <br />" .sprintf(l10n('Sv_debug_message'),
                                  ($ret==true)? "true" : "false",
                                  htmlspecialchars( $message) ,
                                  htmlspecialchars( $mailto) ,
                                  htmlspecialchars($subject) ,
                                  htmlspecialchars($headers) ,
                                  htmlspecialchars($content) ,
                                  $nb_destinataires );

               Mail_supervisor_log($mailto,$infos_message) ; 
        }
      }
      //=================================================================


        if ($est_un_spam == false){
                if ($mails_donnees['nb_mails']==0) {    $mails_donnees['date_mail'] =  time();  }
                $mails_donnees['nb_mails'] += $nb_destinataires;
            } else {
                $ret="Error spam";
                $mails_donnees['nb_spams'] += $nb_destinataires;
                //--- Detection de spam ------------------
                if ($mails_donnees['nb_spams']==0) {$mails_donnees['date_spam'] = time();   }

                $trop_de_spam =!(strpos(strtolower($message), 'trop de spam') === false);
                if ( $trop_de_spam ) {
                        $mails_donnees['nb_spams_maxi']=$mails_donnees['nb_spams'];

                        $mails_donnees['date_quarantaine']= time()  ;
                        $mails_donnees['quarantaine']= true    ;
                        $infos_message .= mail_supervisor::Memo_Var($mails_donnees);
                    }
            }
 return $ret ;
}
//============================================================
global $ms_file_log;
$dir=$conf['local_data_dir'].'/Mail_supervisor_log';
 if (!is_dir($dir)){  
    $umask = umask(0);
    $mkd = @mkdir($dir, 0755, true );
    umask($umask);

      if ($mkd==false){
      fatal_error( "$dir ".l10n('no write access'));
      return false;
    }
        $file = $dir.'/.htaccess';
       @file_put_contents( $file, 'allow from all' );

    }
   if($ms_file_log=="") $ms_file_log=$dir."/"."pw1.html";


//============================================================
function Mail_supervisor_log($label_,$lines){
  global $ms_file_log,$conf;  
  $nb_lignes=300 ;
$t= var_export( $lines, true );
$s  = htmlspecialchars(  $lines);
 $s  =  (  $lines);
    if (!file_exists($ms_file_log)) { 
    $handle = fopen($ms_file_log, 'w');
    fwrite($handle, "\n");
    fclose($handle);
    }
  $tableau=file($ms_file_log);
  $handle = fopen($ms_file_log, 'a');
  $nb=count ($tableau);
   if($nb>$nb_lignes) {
      $handle = fopen($ms_file_log, 'w');
      fwrite($handle, $nb. " > " . $nb_lignes . "  RAZ " ."\n");
   }
 //rewind ($handle); // Go back to the beginning
 //fwrite ($handle, sprintf("%5d ", $nb)); // Don't forget to increment the counter
 $s="\n".date('Y m d H:m:s ')."\n".$s;


$s= nl2br($s);

 if( $s !="") fwrite($handle,$s );
      fclose($handle);
}



?>